{=============================================================================}
{   LsAutoFinanceCalc
    =================
    Version   :  1.0.0.0  for Windows 9x, Me, 2k or XP.
    Compiler  :  Delphi versions 5 to 7.
    Author    :  Leo D. Shih
                 e-mail: ldshih@ecn.ab.ca
    Copyright :  (C)2003 by Leo D. Shih, all rights reserved

    Note:
    =====
    This application program is compiled by Delphi 7.  If you want to
    re-compile it under Delphi 5 or 6, you may encounter error messages
    due to some properties that are not available in D5 or D6.  If this
    is case, just ignore all error messages then proceed as usual.
}
{=============================================================================}
{
  DISCLAIMER AND LICENSE
  ========================
  This software (LsAutoFinanceCalc.exe and associated Delphi source code
  files) is currently distributed as Freeware, and is provided 'as-is',
  without warranty of any kind, either expressed or implied.  In no event
  shall the author (i.e. the copyright holder) be held liable for any
  losses or damages arising from the use of this software.

  Permission to use, copy, modify and/or distribute this software for any
  purpose and without fee is hereby granted, provided that the following
  conditions are met:

  (1)  This Copyright notice may not be removed or altered from any
       distributions.

  (2)  The origin of this software must not be misrepresented;  you must
       not claim that you wrote the original software.

  (3)  Modified source code must be plainly marked as such, and must not
       be misrepresented as being the original software.

  (4)  If you use this software, or any part thereof, in your application
       software, an acknowledgment in your application's documentation
       would be appreciated.

  (5)  If your application software is to be distributed as a commercial
       product, in addion to the above conditions, an express written
       consent from the author is required.

  REGISTERED TRADEMARKS
  =====================
  Windows is a trademark of Microsoft Corporation
  Delphi is a trademark of Borland Software Corporation

}
{=============================================================================}



unit AutoFinanceMainUnit;

interface

uses
  Windows, Messages, SysUtils, {Variants,} Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, ComCtrls, Buttons, ShellAPI, LsAlignNumEdit;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    Panel2: TPanel;
    Panel4: TPanel;
    BtnNext: TBitBtn;
    BtnBack: TBitBtn;
    TabSheet2: TTabSheet;
    TabSheet3: TTabSheet;
    PageControl2: TPageControl;
    TabSheet_2: TTabSheet;
    TabSheet_3: TTabSheet;
    TabSheet_4: TTabSheet;
    TabSheet_5: TTabSheet;
    TabSheet_6: TTabSheet;
    TabSheet_7: TTabSheet;
    TabSheet_8: TTabSheet;
    TabSheet_9: TTabSheet;
    BtnCalc: TBitBtn;
    TabSheet_1: TTabSheet;
    Label42: TLabel;
    Label43: TLabel;
    Label44: TLabel;
    PnlTabSht1_1: TPanel;
    Image1: TImage;
    Label45: TLabel;
    PnlTabSht1_2: TPanel;
    PnlTabSht2_1: TPanel;
    LblTabSht2_1: TLabel;
    LblTabSht2_2: TLabel;
    PnlTabSht2_2: TPanel;
    LblTabSht2_3: TLabel;
    LblTabSht2_4: TLabel;
    LblURL_0: TLabel;
    PnlTabSht3_1: TPanel;
    LblTabSht3_1: TLabel;
    LblTabSht3_2: TLabel;
    PnlTabSht3_2: TPanel;
    LblTabSht3_4: TLabel;
    LblTabSht3_3: TLabel;
    LblURL_1: TLabel;
    PnlTabSht4_1: TPanel;
    LblTabSht4_1: TLabel;
    Label11: TLabel;
    PnlTabSht4_2: TPanel;
    Label12: TLabel;
    LblTabSht4_4: TLabel;
    LblTabSht4_5: TLabel;
    LblTabSht4_6: TLabel;
    LbeTabSht4_7: TLabel;
    PnlTabSht5_1: TPanel;
    PnlTabSht5_2: TPanel;
    LblTabSht5_1: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label20: TLabel;
    PnlTabSht6_2: TPanel;
    PnlTabSht6_1: TPanel;
    LblTabSht6_1: TLabel;
    LblTabSht6_2: TLabel;
    LblTabSht6_3: TLabel;
    LblTabSht6_4: TLabel;
    MemoTabSht6_1: TMemo;
    PnlTabSht7_1: TPanel;
    LblTabSht7_1: TLabel;
    LblTabSht7_2: TLabel;
    PnlTabSht7_2: TPanel;
    LblTabSht7_3: TLabel;
    LblTabSht7_4: TLabel;
    LblTabSht7_5: TLabel;
    LblTabSht7_6: TLabel;
    LblURL_2: TLabel;
    LblTabSht6_5: TLabel;
    PnlTabSht8_1: TPanel;
    LblTabSht8_1: TLabel;
    LblTabSht8_2: TLabel;
    PnlTabSht8_2: TPanel;
    MemoTabSht8_1: TMemo;
    Label15: TLabel;
    LblURL_3: TLabel;
    PnlTabSht9_1: TPanel;
    LblTabSht9_1: TLabel;
    Label16: TLabel;
    PnlTabSht9_2: TPanel;
    MemoTabSht9_1: TMemo;
    MemoTabSht1_1: TMemo;
    Panel3: TPanel;
    Shape1: TShape;
    LblRslt_1: TLabel;
    LblRslt_2: TLabel;
    LblRslt_3: TLabel;
    LblRslt_4: TLabel;
    LblRslt_5: TLabel;
    LblRslt_6: TLabel;
    LblRslt_7: TLabel;
    LblRslt_8: TLabel;
    LblRslt_9: TLabel;
    LblRslt_10: TLabel;
    LblRslt_11: TLabel;
    Shape2: TShape;
    LblVal_1: TLabel;
    LblVal_2: TLabel;
    LblVal_3: TLabel;
    LblVal_4: TLabel;
    LblVal_5: TLabel;
    LblVal_6: TLabel;
    LblVal_7: TLabel;
    LblVal_8: TLabel;
    LblVal_9: TLabel;
    LblVal_10: TLabel;
    Shape_1: TShape;
    Panel5: TPanel;
    Panel8: TPanel;
    Memo2: TMemo;
    PageControl3: TPageControl;
    TabSheet4: TTabSheet;
    TabSheet5: TTabSheet;
    PnlTabSht34_1: TPanel;
    PnlTabSht35_1: TPanel;
    LblTabSht35_2: TLabel;
    Panel9: TPanel;
    LblTabSht35_1: TLabel;
    LblTabSht35_3: TLabel;
    LblTabSht35_4: TLabel;
    LblTabSht35_5: TLabel;
    Shape3: TShape;
    LblTabSht35_6: TLabel;
    BtnTabSht35_1: TBitBtn;
    BtnTabSht35_2: TBitBtn;
    Panel10: TPanel;
    LblTabSht34_1: TLabel;
    LblTabSht34_2: TLabel;
    LblTabSht34_3: TLabel;
    LblTabSht34_4: TLabel;
    LblTabSht34_5: TLabel;
    Shape4: TShape;
    LblTabSht34_6: TLabel;
    LblTabSht34_7: TLabel;
    BtnTabSht34_2: TBitBtn;
    BtnTabSht34_1: TBitBtn;
    Panel11: TPanel;
    Panel12: TPanel;
    Panel13: TPanel;
    RichEdit1: TRichEdit;
    Image4: TImage;
    Label1: TLabel;
    LblURL_0a: TLabel;
    LblURL_3a: TLabel;
    LblURL_2a: TLabel;
    LblURL_5: TLabel;
    LblURL_6: TLabel;
    LblURL_7: TLabel;
    LblURL_8: TLabel;
    LblURL_9: TLabel;
    LblURL_10: TLabel;
    LblURL_11: TLabel;
    LblURL_12: TLabel;
    Image2: TImage;
    Label2: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    LblURL_4: TLabel;
    BtnClear: TBitBtn;
    Panel6: TPanel;
    procedure BtnNextClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure BtnBackClick(Sender: TObject);
    procedure LinkToUrl(aURL: string; IsMailto: Boolean);
    function createEdit(aLeft, aTop, aWidth: integer; aMask: string; aParent: TWinControl): TLsAlignNumEdit;
    procedure LblURLClick(Sender: TObject);
    procedure ErrMessage(PageIndex: integer);
    procedure FormShow(Sender: TObject);
    procedure BtnCalcClick(Sender: TObject);
    procedure BtnTabSht35_1Click(Sender: TObject);
    procedure BtnTabSht35_2Click(Sender: TObject);
    procedure PageControl3Change(Sender: TObject);
    procedure BtnTabSht34_1Click(Sender: TObject);
    procedure BtnTabSht34_2Click(Sender: TObject);
//    procedure PageControl1Change(Sender: TObject);
    procedure BtnClearClick(Sender: TObject);

  private
    { Private declarations }
  public
    { Public declarations }
    FMSRP, FCapCost, FNetCapCost,
      FCapCostReduction,
      FDownPmt, FTradeInCR, FRebate,
      FResVal_Dlr, FResVal_PCent,
      FMoneyFactor, FIntRate,
      FDeprFee, FFinFee,
      FMonLeaseFee, FMonPmt,
      FCarPrice, FLoanAmt, FTotCost: Double;
    FTerm: integer;
    FURL: string;
    NumEdit1, NumEdit2, NumEdit3,
      NumEdit4, NumEdit5, NumEdit6,
      NumEdit7, NumEdit8, NumEdit9,
      NumEdit10, NumEdit11, NumEdit12,
      NumEdit13, NumEdit14, NumEdit15,
      NumEdit16, NumEdit17, NumEdit18,
      NumEdit19, NumEdit20, NumEdit21,
      NumEdit22, NumEdit23, NumEdit24,
      NumEdit25 : TLsAlignNumEdit;
//    function createEdit(aLeft, aTop, aWidth: integer; aParent: TWinControl): TLsAlignNumEdit;
    function LoanPayment(Principal, InterestRate: Double; TotalNumPay,
      NumPayPerYr: integer): Double;
    function LoanPrincipal(Payment, InterestRate: Double; TotalNumPay,
      NumPayPerYr: integer): Double;
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}


procedure TForm1.FormCreate(Sender: TObject);
begin
  Shape_1.Top := 30;
  Shape_1.Visible := False;
  NumEdit1  := CreateEdit(144, 16, 77, ',##0.00', PnlTabSht2_1);  //TabSheet_2);
  NumEdit2  := CreateEdit(166, 16, 77, ',##0.00', PnlTabSht3_1);  //TabSheet_3);
  NumEdit3  := CreateEdit(156, 52, 77, ',##0.00', PnlTabSht4_2);  //TabSheet_4);
  NumEdit4  := CreateEdit(156, 76, 77, ',##0.00', PnlTabSht4_2);  //TabSheet_4);
  NumEdit5  := CreateEdit(156, 100, 77, ',##0.00', PnlTabSht4_2);  //TabSheet_4);
  NumEdit6  := CreateEdit(152, 16, 77, ',##0', PnlTabSht5_1);   //TabSheet_5);
  NumEdit7  := CreateEdit(160, 16, 77, ',##0.00', PnlTabSht6_2);  //TabSheet_6);
  NumEdit8  := CreateEdit(160, 44, 77, '#0.00', PnlTabSht6_2);  //TabSheet_6);
  NumEdit9  := CreateEdit(164, 8, 77, '0.000000', PnlTabSht7_2);  //TabSheet_7);
  NumEdit10 := CreateEdit(164, 32, 77, '#0.0000', PnlTabSht7_2);  //TabSheet_7);

  NumEdit11 := CreateEdit(186, 44, 77, ',##0.00', PnlTabSht34_1);
  NumEdit11.TabOrder := 0;
  NumEdit12 := CreateEdit(186, 74, 77, ',##0.00', PnlTabSht34_1);
  NumEdit12.TabOrder := 1;
  NumEdit13 := CreateEdit(186, 104, 77, '#0', PnlTabSht34_1);
  NumEdit13.TabOrder := 2;
  NumEdit14 := CreateEdit(186, 134, 77, '#0.0000', PnlTabSht34_1);
  NumEdit14.TabOrder := 3;
  NumEdit15 := CreateEdit(186, 172, 77, ',##0.00', PnlTabSht34_1);
  with NumEdit15 do
  begin
    TabStop := False;
    Font.Style := [fsBold];
    Font.Color := clBlue;
  end;
  NumEdit16 := CreateEdit(186, 204, 77, ',##0.00', PnlTabSht34_1);
  with NumEdit16 do
  begin
    TabStop := False;
    Font.Color := clBlue;
    Font.Style := [fsBold];
  end;
  NumEdit21 := CreateEdit(184, 60, 77, ',##0.00', PnlTabSht35_1);
  NumEdit21.TabOrder := 0;
  NumEdit22 := CreateEdit(184, 92, 77, ',#0', PnlTabSht35_1);
  NumEdit22.TabOrder := 1;
  NumEdit23 := CreateEdit(184, 124, 77, ',#0.0000', PnlTabSht35_1);
  NumEdit23.TabOrder := 2;
  NumEdit24 := CreateEdit(184, 156, 77, ',##0.00', PnlTabSht35_1);
  NumEdit24.TabOrder := 3;
  NumEdit25 := CreateEdit(184, 200, 77, ',##0.00', PnlTabSht35_1);
  with NumEdit25 do
  begin
    TabStop := False;
    Font.Style := [fsBold];
    Font.Color := clBlue;
  end;
  PageControl1.ActivePage := TabSheet1;
  PageControl2.ActivePage := TabSheet_1;
  PageControl3.ActivePage := TabSheet4;
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  BtnNext.Caption := '&Start';
  BtnNext.Enabled := True;
  BtnNext.SetFocus;
  BtnBack.Enabled := False;
  BtnCalc.Enabled := False;
end;


procedure TForm1.BtnNextClick(Sender: TObject);
begin
  with PageControl2 do
  begin
    case ActivePage.PageIndex of
      0:  begin
            ActivePage := TabSheet_2;
            Shape_1.Top := 30;
            NumEdit1.SetFocus;
            BtnBack.Enabled := True;
          end;
      1:  begin   //MSRP
            if NumEdit1.Value <> 0 then
            begin
              LblVal_1.Caption := NumEdit1.Text;
              FMSRP := NumEdit1.Value;
              ActivePage := TabSheet_3;
              NumEdit2.SetFocus;
              Shape_1.Top := 54;
            end
            else begin
              ErrMessage(1);
              NumEdit1.SetFocus;
            end;

          end;
      2:  begin  //CapCost
            if NumEdit2.Value <> 0 then
            begin
              FCapCost := NumEdit2.Value;
              LblVal_2.Caption := NumEdit2.Text;
              ActivePage := TabSheet_4;
              Shape_1.Top := 78;
              NumEdit3.SetFocus;
            end
            else begin
              ErrMessage(2);
              NumEdit2.SetFocus;
            end;
          end;
      3:  begin  //CapCost Reduction
            if (NumEdit3.Value <> 0) or (NumEdit4.Value <> 0) or
               (NumEdit5.Value <> 0) then
            begin
              FCapCostReduction := NumEdit3.Value + NumEdit4.Value +
                                   NumEdit5.Value;
              LblVal_3.Caption := FormatFloat(',##0.00', FCapCostReduction);
            end
            else begin
              ErrMessage(3);
              FCapCostReduction := 0;
              LblVal_3.Caption := '0.00';
            end;
            ActivePage := TabSheet_5;
            NumEdit6.SetFocus;
            Shape_1.Top := 102;
          end;
      4:  begin  //Lease Term
            if (NumEdit6.Value <> 0) then
            begin
              LblVal_4.Caption := IntToStr(NumEdit6.ValueAsInt);
              FTerm := NumEdit6.ValueAsInt;
              ActivePage := TabSheet_6;
              NumEdit7.SetFocus;
              Shape_1.Top := 126;
            end
            else begin
              ErrMessage(4);
              NumEdit6.SetFocus;
            end;
          end;
      5:  begin  //Residual Value
            if (NumEdit7.Value <> 0) and (NumEdit8.Value = 0) then
            begin
              FResVal_Dlr := NumEdit7.Value;
              LblVal_5.Caption := NumEdit7.Text;
            end
            else if (NumEdit7.Value = 0) and (NumEdit8.Value <> 0) then
            begin
              FResVal_Dlr := FMSRP * ( NumEdit8.Value / 100);
              LblVal_5.Caption := FormatFloat(',##0.00', FResVal_Dlr);
            end
            else if (NumEdit7.Value = 0) and (NumEdit8.Value = 0) then
            begin
              ErrMessage(5);
              if (FTerm <= 24) then
                FResVal_Dlr := FMSRP * 0.65
              else if (FTerm > 24) and (FTerm <= 36) then
                FResVal_Dlr := FMSRP * 0.57
              else if (FTerm > 36) and (FTerm <= 48) then
                FResVal_Dlr := FMSRP * 0.49
              else if (FTerm > 48) and (FTerm <= 60) then
                FResVal_Dlr := FMSRP * 41;
              LblVal_5.Caption := FormatFloat(',##0.00', FResVal_Dlr);
            end;
            ActivePage := TabSheet_7;
            NumEdit9.SetFocus;
            Shape_1.Top := 150;
          end;
      6:  begin  //Money Factor
            if (NumEdit9.Value <> 0) or (NumEdit10.Value <> 0) then
            begin
              if (NumEdit9.Value <> 0) and (NumEdit10.Value = 0) then
              begin
                FMoneyFactor := NumEdit9.Value;
                LblVal_6.Caption := NumEdit9.Text;
              end
              else if (NumEdit9.Value = 0) and (NumEdit10.Value <> 0) then
                                                                                     begin
                FMoneyFactor := NumEdit10.Value / 2400;
                LblVal_6.Caption := FormatFloat('#0.000000', FMoneyFactor);
              end;
              ActivePage := TabSheet_8;
              Shape_1.Top := 174;
            end
            else if (NumEdit9.Value = 0) and (NumEdit10.Value = 0) then
            begin
              ErrMessage(6);
              NumEdit9.SetFocus;
            end;
          end;
      7:  begin  //Sales Tax
            LblVal_7.Caption := 'Not included';
            ActivePage := TabSheet_9;
            BtnCalc.Enabled := True;
            BtnCalc.SetFocus;
          end;
      8:  begin
            ActivePage := TabSheet_9;
            BtnCalc.SetFocus;
          end;
    end;
    Shape_1.Visible :=  (ActivePage.PageIndex > 0) and
                        (ActivePage.PageIndex < 8);
    BtnNext.Enabled :=  ActivePage.PageIndex <> 8;
    if ActivePage.PageIndex = 0 then
      BtnNext.Caption := '&Start'
    else
      BtnNext.Caption := '&Next';
    BtnCalc.Enabled := ActivePage.PageIndex = 8;
  end;
end;

procedure TForm1.BtnBackClick(Sender: TObject);
begin
  with PageControl2 do
  begin
    case ActivePage.PageIndex of
      8:  begin
            ActivePage := TabSheet_8;
            Shape_1.Top := 176;
          end;
      7:  begin
            ActivePage := TabSheet_7;
            Shape_1.Top := 152;
            BtnNext.Enabled := True;
          end;
      6:  begin
            ActivePage := TabSheet_6;
            Shape_1.Top := 128;
          end;
      5:  begin
            ActivePage := TabSheet_5;
            Shape_1.Top := 104;
          end;
      4:  begin
            ActivePage := TabSheet_4;
            Shape_1.Top := 80;
          end;
      3:  begin
            ActivePage := TabSheet_3;
            Shape_1.Top := 56;
          end;
      2:  begin
            ActivePage := TabSheet_2;
            Shape_1.Top := 32;
          end;
      1:  begin
            ActivePage := TabSheet_1;
            Shape_1.Top := 32;
          end;
      0:  begin
            ActivePage := TabSheet_1;
            Shape_1.Top := 32;
          end;
    end;
    Shape_1.Visible :=  (ActivePage.PageIndex > 0) and
                        (ActivePage.PageIndex < 8);
    BtnBack.Enabled :=  ActivePage.PageIndex <> 0;
    if ActivePage.PageIndex = 0 then
      BtnNext.Caption := '&Start'
    else
      BtnNext.Caption := '&Next';
    BtnCalc.Enabled := ActivePage.PageIndex = 8;
  end;
end;

function TForm1.createEdit(aLeft, aTop, aWidth: integer; aMask: string; aParent: TWinControl): TLsAlignNumEdit;
begin
  Result := TLsAlignNumEdit.Create(aParent);
  Result.Parent :=  aParent;
  Result.SetBounds(aLeft, aTop, aWidth, 16);
  Result.Font.Name := 'MS Sans Serif';
  Result.Font.Size := 9;
  Result.Mask := aMask;   //',##0.00';
  Result.Visible := True;
end;

procedure TForm1.LinkToUrl(aURL: string; IsMailto: Boolean);
var
  Param: AnsiString;

  function AddNullToStr(Path: string): string;
  begin
    if Path = '' then exit;
    if Path[Length(Path)] <> #0 then
      Result := Path + #0
    else
      Result := Path;
  end;

begin
  if (IsMailTo = True) then
    Param := AddNullToStr(aURL)
  else
    Param := 'http://' + AddNullToStr(aURL);
  ShellExecute(0,
               'open',
               pChar(Param),
               nil,
               nil,
               SW_SHOWNORMAL);
end;

procedure TForm1.LblURLClick(Sender: TObject);
var
  FMailTo: Boolean;
begin
  FMailTo := False;
  FURL := '';
  with Sender as TLabel do
  begin
    case Tag of
       0: begin
            FURL := LblURL_0.Caption;
            FMailTo := False;
          end;
       1: begin
            FURL := LblURL_1.Caption;
            FMailTo := False;
          end;
       2: begin
            FURL := LblURL_2.Caption;
            FMailTo := False;
          end;
       3: begin
            FURL := LblURL_3.Caption;
            FMailTo := False;
          end;
       4: begin
            FURL := LblURL_4.Caption;
            FMailTo := True;
          end;
       5: begin
            FURL := LblURL_5.Caption;
            FMailTo := False;
          end;
       6: begin
            FURL := LblURL_6.Caption;
            FMailTo := False;
          end;
       7: begin
            FURL := LblURL_7.Caption;
            FMailTo := False;
          end;
       8: begin
            FURL := LblURL_8.Caption;
            FMailTo := False;
          end;
       9: begin
            FURL := LblURL_9.Caption;
            FMailTo := False;
          end;
      10: begin
            FURL := LblURL_10.Caption;
            FMailTo := False;
          end;
      11: begin
            FURL := LblURL_11.Caption;
            FMailTo := False;
          end;
      12: begin
            FURL := 'www.jdpower.com/cc/auto/auto.jsp';  //LblURL_1.Caption;
            FMailTo := False;
          end;
    end;  //case
  end;
  LinkToURL(FURL, FMailTo);
end;

function TForm1.LoanPayment(Principal, InterestRate: Double; TotalNumPay,
  NumPayPerYr: integer): Double;
var
  Temp: Double;
begin
  Temp := exp(-TotalNumPay * ln(1.0 + interestRate / 100.0 / NumPayPerYr));
  Result := Principal * InterestRate / 100.0 / NumPayPerYr / (1.0 - Temp);
end;

function TForm1.LoanPrincipal(Payment, InterestRate: Double; TotalNumPay,
  NumPayPerYr: integer): Double;
var
  Temp: Double;
begin
  Temp := exp(-TotalNumPay * ln(1.0 + InterestRate / 100.0 / NumPayPerYr));
  Result := Payment * NumPayPerYr * 100.0 / InterestRate * (1.0 - Temp);
end;

procedure TForm1.ErrMessage(PageIndex: integer);
var
  eMsg: string;
  DlgType: TMsgDlgType;
begin
  DlgType := mtError;
  case PageIndex of
    1:  begin   //MSRP
          eMsg := 'You must enter a value for MSRP';
          DlgType := mtError;
        end;
    2:  begin  //CapCost
          eMsg := 'You must enter the lease price (Cap Cost) for your vehicle.' + #13 +
                  'If you don''t have it yet, you can use True Market value (TMV)' + #13 +
                  'from Edmunds'' website';
          DlgType := mtError;
        end;
    3:  begin  //CapCost Reduction
          eMsg := 'Since you have not entered any Capitalized Cost Reductions,' + #13 +
                  'the Net Capitalized Cost will be same as Base Capitalized Cost';
          DlgType := mtWarning;
        end;
    4:  begin  //LeaseTerm
          eMsg := 'You must enter the length of your lease (in months)';
          DlgType := mtError;
        end;
    5:  begin  //Residual Value
          eMsg := 'Since You have not entered a Residual Value or Persentage of MSRP,' + #13 +
                  'the Residual Value will be estimated based on the lease term';        DlgType := mtError;
        end;
    6:  begin  //Money Factor
          eMsg := 'Either Money Factor or Interest Rate must be entered.' + #13 +
                  'You can find out the current Car-loan interest rate' + #13 +
                  'from www.bankrate.com website';
          DlgType := mtError;
        end;
  end;  //case
  MessageDlg(eMsg, DlgType, [mbOK], 0);
end;

procedure TForm1.BtnCalcClick(Sender: TObject);
begin
  FNetCapCost := FCapCost - FCapCostReduction;
  FDeprFee := (FNetCapCost -  FResVal_Dlr) / FTerm;
  FFinFee := (FNetCapCost + FResVal_Dlr) * FMoneyFactor;
  FMonLeaseFee := FDeprFee + FFinFee;
  LblVal_8.Caption := FormatFloat(',##0.00', FDeprFee);
  LblVal_9.Caption := FormatFloat(',##0.00', FFinFee);
  LblVal_10.Caption := FormatFloat(',##0.00', FMonLeaseFee);
end;

procedure TForm1.BtnTabSht35_1Click(Sender: TObject);
var
  FAffordPrice: double;
  errMsg: string;
begin
  if (NumEdit21.Value = 0) or (NumEdit22.Value = 0) or (NumEdit23.Value = 0) then
  begin
    if (NumEdit21.Value = 0) then
      errMsg := 'You must enter the amount of your Monthly Payment'
    else if (NumEdit22.Value = 0) then
      errMsg := 'You must enter the Length of Loan (in years)'
    else if (NumEdit23.Value = 0) then
      errMsg := 'You must enter the Annual Interest Rate (in percent)';
    MessageDlg(errMsg, mtError, [mbOK], 0);
    if NumEdit21.Value = 0 then NumEdit21.SetFocus
    else if NumEdit22.Value = 0 then NumEdit22.SetFocus
    else if NumEdit23.Value = 0 then NumEdit23.SetFocus;
    exit;
  end
  else begin
    FMonPmt := NumEdit21.Value;
    FTerm := NumEdit22.ValueAsInt;
    FIntRate := NumEdit23.Value;
    FDownPmt := NumEdit24.Value;
    FAffordPrice := LoanPrincipal(FMonPmt, FIntRate, FTerm * 12, 12) + FDownPmt;
    NumEdit25.Value := FAffordPrice;
  end;
end;

procedure TForm1.BtnTabSht34_1Click(Sender: TObject);
var
  errMsg: string;
begin
  if (NumEdit11.Value = 0) or (NumEdit13.Value = 0) or (NumEdit14.Value = 0) then
  begin
    if (NumEdit11.Value = 0) then
      errMsg := 'You must enter the Price of vehicle.'
    else if (NumEdit13.Value = 0) then
      errMsg := 'You must enter the Length of Loan in years'
    else if (NumEdit14.Value = 0) then
      errMsg := 'You must enter the Annual Interest Rate in percent';
    MessageDlg(errMsg, mtError, [mbOK], 0);
    if (NumEdit11.Value = 0) then
      NumEdit11.SetFocus
    else if (NumEdit13.Value = 0) then
      NumEdit13.SetFocus
    else if (NumEdit14.Value = 0) then
      NumEdit14.SetFocus;
    exit;
  end
  else begin
    FCarPrice := NumEdit11.Value;
    FDownPmt := NumEdit12.Value;
    FLoanAmt := FCarPrice - FDownPmt;
    Fterm := NumEdit13.ValueAsInt * 12;
    FIntRate := NumEdit14.Value;
    FMonPmt := LoanPayment(FLoanAmt, FIntRate, FTerm, 12);
    NumEdit15.Value := FMonPmt;
    FTotCost := FMonPmt * FTerm + FDownPmt;
    NumEdit16.Value := FTotCost;
  end;
end;

procedure TForm1.BtnTabSht35_2Click(Sender: TObject);
begin
  NumEdit21.Value := 0;
  NumEdit22.Value := 0;
  NumEdit23.Value := 0;
  NumEdit24.Value := 0;
  NumEdit25.Value := 0;
  NumEdit21.SetFocus;
end;

procedure TForm1.BtnTabSht34_2Click(Sender: TObject);
begin
  NumEdit11.Value := 0;
  NumEdit12.Value := 0;
  NumEdit13.Value := 0;
  NumEdit14.Value := 0;
  NumEdit15.Value := 0;
  NumEdit16.Value := 0;
  NumEdit11.SetFocus;
end;

procedure TForm1.BtnClearClick(Sender: TObject);
begin
  NumEdit1.Value := 0;
  NumEdit2.Value := 0;
  NumEdit3.Value := 0;
  NumEdit4.Value := 0;
  NumEdit5.Value := 0;
  NumEdit6.Value := 0;
  NumEdit7.Value := 0;
  NumEdit8.Value := 0;
  NumEdit9.Value := 0;
  NumEdit10.Value := 0;
  LblVal_1.Caption := '';
  LblVal_2.Caption := '';
  LblVal_3.Caption := '';
  LblVal_4.Caption := '';
  LblVal_5.Caption := '';
  LblVal_6.Caption := '';
  LblVal_7.Caption := '';
  LblVal_8.Caption := '';
  LblVal_9.Caption := '';
  LblVal_10.Caption := '';
  PageControl2.ActivePage := TabSheet_1;
  BtnNext.Enabled := True;
  BtnNext.SetFocus;
end;


procedure TForm1.PageControl3Change(Sender: TObject);
begin
  if PageControl3.ActivePage = TabSheet4  then
    NumEdit11.SetFocus
  else if PageControl3.ActivePage = TabSheet5 then
    NumEdit21.SetFocus;
end;




end.


